#pragma once
#define SDL_MAIN_HANDLED
#include <SDL2/SDL.h>
#include <atomic>

class AlivcAudioRender {
public:
    AlivcAudioRender();
    ~AlivcAudioRender();
    void init();
    void uninit();
    void renderData(void *pcmData, int pcmDataLength, int sampleRate, int nbSamples, int channels, int format);
    void setMute(bool mute);
    void setAudioDevice(int index);
    void clearQueue();

private:
    SDL_AudioSpec mSpec{0};
    SDL_AudioDeviceID mDevID{0};
    std::atomic_bool mMute{false};
    int mAudioDeviceIndex{-1};
};
