#ifndef Alivc_Network_Manager_h
#define Alivc_Network_Manager_h

#include <QObject>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <functional>

class AlivcAppServerBaseAPI : public QObject
{
  Q_OBJECT

public:
    AlivcAppServerBaseAPI(QObject *parent);
    ~AlivcAppServerBaseAPI();

    void Get(const QString& url, std::function<void(int, QByteArray)> completionFunc);
    void Post(const QString& url, const QByteArray &data, std::function<void(int, QByteArray)> completionFunc);

    void GetVideoList(std::function<void(int, QByteArray)> completionFunc);
    void GetStsInfo(std::function<void(int, QByteArray)> completionFunc);

public slots:
    void OnHttpRequestFinished(QNetworkReply *reply);

 protected:
    QNetworkAccessManager mNetworkAcessManager;
    QNetworkRequest mHttpRequest;
    std::function<void(int, QByteArray data)> mCompletionFunc;
};

#endif //Alivc_Network_Manager_h