#ifndef AlivcLivePlayr_List_Dialog_h
#define AlivcLivePlayr_List_Dialog_h

#include <QDialog>
#include <QTableView>
#include <QPushButton>
#include "AlivcPlayListModel.h"
#include "AlivcNetworkManager.h"

class AlivcPlayListDlg : public QDialog
{
  Q_OBJECT

public:
  AlivcPlayListDlg(QWidget *parent);
  ~AlivcPlayListDlg();

  QString GetCurrentVideoId() { return mCurrentVid; }

private:
  void OnPlayButtonClicked(bool checked);

private:
  void InitLayout();
  void InitEvent();
  void InitData();

private:
  QTableView* mPlayListView{ nullptr };
  QPushButton* mPlayButton{ nullptr };
  AlivcPlayListModel* mPlayListModel{ nullptr };
  AlivcAppServerBaseAPI* mGetVideoListApid{ nullptr };
  QString mCurrentVid;
};

#endif //AlivcLivePlayr_List_Dialog_h