#include "AlivcPlayerCacheConfigDlg.h"
#include "QFileDialog"


AlivcPlayerCacheConfigDlg::AlivcPlayerCacheConfigDlg(QWidget *parent) : QDialog(parent), ui(new Ui::AlivcPlayerCacheConfigDlg)
{
    setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint);
    ui->setupUi(this);
}

void AlivcPlayerCacheConfigDlg::SetCacheConfig(const AVPCacheConfig &config)
{
    ui->checkBoxEnable->setChecked(config.enable);
    ui->editMaxDuration->setText(QString::number(config.maxDuration));
    ui->editMaxSizeMB->setText(QString::number(config.maxSizeMB));
    if (config.path) {
        ui->editPath->setText(QString::fromLocal8Bit(config.path));
    }
}

AVPCacheConfig AlivcPlayerCacheConfigDlg::GetCacheConfig()
{
    AVPCacheConfig ret;
    ret.enable = ui->checkBoxEnable->isChecked();
    ret.maxDuration = ui->editMaxDuration->text().toInt();
    ret.maxSizeMB = ui->editMaxSizeMB->text().toInt();
    QString path = ui->editPath->text();
    ret.path = strdup(path.replace('/', '\\').toLocal8Bit());
    return ret;
}

void AlivcPlayerCacheConfigDlg::on_btnSelectFolder_clicked()
{
    QString path = QFileDialog::getExistingDirectory(this, QStringLiteral("ѡ񱣴Ŀ¼"), "./",
                                                     QFileDialog::ShowDirsOnly | QFileDialog::DontUseNativeDialog);
    ui->editPath->setText(path);
}

void AlivcPlayerCacheConfigDlg::on_btnDone_clicked()
{
    accept();
}
