#ifndef Alivc_Player_Config_Dlg_h
#define Alivc_Player_Config_Dlg_h

#include <QDialog>
#include <QLabel>
#include <QComboBox>
#include <QLineEdit>
#include <QCheckBox>
#include <QPushButton>
#include <QHBoxLayout>
#include <QLineEdit>
#include "sdk_headers/AliPlayer.h"

using namespace alivc_player;

class AlivcPlayerConfigDlg : public QDialog
{
  Q_OBJECT

public:
    AlivcPlayerConfigDlg(QWidget *parent = Q_NULLPTR, AVPConfig* config = nullptr);
    ~AlivcPlayerConfigDlg();
    AVPConfig GetAvConfig() {return mAvConfig; }
	void SetAvConfig(const AVPConfig& config) { mAvConfig = config; }

private:
  void InitLayout();
  void InitEvent();
  void InitData();
  QHBoxLayout* AddConfigItem(QString configName, QWidget* editWidget);
  void AddNumberVaild(QLineEdit* edit);

private slots:
  void OnConfigButtonClicked(bool checked);

private:
  AVPConfig mAvConfig;

  QLineEdit* mRefererEdit{ nullptr };
  QLineEdit* mHttpProxyEdit{ nullptr };
  QLineEdit* mUserAgentEdit{ nullptr };
  QLineEdit* mNetworkTimeoutEdit{ nullptr };
  QLineEdit* mNetworkRetryCountEdit{ nullptr };
  QLineEdit* mMaxBufferDurationEdit{ nullptr };
  QLineEdit* mStartBufferDurationEdit{ nullptr };
  QLineEdit* mHighBufferDurationEdit{ nullptr };
  QLineEdit* mMaxDelayTimeEdit{ nullptr };
  QLineEdit* mHttpHeadersEdit{ nullptr };
  QCheckBox* mShowLastFrameWhenStop{ nullptr };
  QPushButton* mConfigButton{ nullptr };
};

#endif //Alivc_Player_Config_Dlg_h