﻿#include "AlivcPlayerMainDlg.h"
#include "AlivcNotifyMgr.h"
#include "AlivcPlayListDlg.h"
#include "AlivcPlayerAddExtSubtitleDlg.h"
#include "AlivcPlayerCacheConfigDlg.h"
#include "AlivcPlayerConfigDlg.h"
#include "QFile"
#include <QApplication>
#include <QDesktopWidget>
#include <QEvent>
#include <QFileDialog>
#include <QHBoxLayout>
#include <QJsonArray>
#include <QJsonDocument>
#include <QJsonObject>
#include <QKeyEvent>
#include <QLineEdit>
#include <QMessageBox>
#include <QVBoxLayout>

#ifndef _DEBUG
#define ENABLE_LOG
#endif// !_DEBUG


using namespace alivc_player;

//static const QString DEFAULT_PLAY_URL = "D://8K_Ex_sample.mp4";
//static const QString DEFAULT_PLAY_URL = "http://livetest.aliyunlive.com/5dbabcec4df04d20b2707369c1598aaa/7613472a0dd34731b1a1457ed5469b3f.m3u8";
//static const QString DEFAULT_PLAY_URL = "rtmp://push-demo.aliyunlive.com/test/stream9877?&auth_key=1550752731-0-0-cc1220a4e19d13e5b9c8bf7fe1b62570";
//static const QString DEFAULT_PLAY_URL = "http://player.alicdn.com/video/aliyunmedia.mp4";
//static const QString DEFAULT_PLAY_URL = "http://mts-sh-out.oss-cn-shanghai.aliyuncs.com/lingkongtest/package/hls/cfa655971b4644eeaa2d4fae9de68b48/79cc41e64a0c42dfb45138c7dcb4c89a/master.m3u8";
//static const QString DEFAULT_PLAY_URL = "rtmp://live.hkstv.hk.lxdns.com/live/hks";
//static const QString DEFAULT_PLAY_URL = "artp://alivc-demo-artp-play.aliyuncs.com/apsara/artp2?auth_key=1566842550-0-0-377c0c074bb1d66aa88021c48052c824";
static const QString DEFAULT_PLAY_URL = "http://player.alicdn.com/video/aliyunmedia.mp4";
//static const QString DEFAULT_PLAY_URL = "https://storage.googleapis.com/wvmedia/clear/h264/tears/tears_sd.mpd";
//static const QString DEFAULT_PLAY_URL = "https://dash.akamaized.net/dash264/TestCasesIOP33/adapatationSetSwitching/5/manifest.mpd";
//static const QString DEFAULT_PLAY_URL = "https://livesim.dashif.org/livesim/start_1800/testpic_2s/Manifest.mpd";
const static QStringList ScallingMode = {QStringLiteral("拉伸"), QStringLiteral("比例填充"), QStringLiteral("裁剪比例填充")};
const static QStringList MirrorMode = {QStringLiteral("无"), QStringLiteral("垂直"), QStringLiteral("水平")};
const static QStringList RotateMode = {QStringLiteral("0"), QStringLiteral("90"), QStringLiteral("180"), QStringLiteral("270")};
const static QStringList RateMode = {QStringLiteral("0.5"), QStringLiteral("1.0"), QStringLiteral("1.5"), QStringLiteral("2.0")};
const static char *verifyFileContent =
        "\xef\xbb\xbf"
        "8Zw2xedPkwFlXbXVXLbLj5Wcl9xYvYMuHSeNGFQe0BIzwRgQuKOpHzNWcj7JxwMqn6G0shdps0yEPuoahv2swjyLufHLVssBoSWT04RYL2g7cOWpMOQc7P"
        "18EeRaiR90S1lktxJ-pe9sKWJ_1xwB_LAi0n9WkHSNk-"
        "32Q4MMWjL8jTLBUUH1nnzLBkojGGPh1HB7y3k6jqDJwCIP2hzKe3nG1JCsS82k6IpqyjESymyz9hk35FUdmMRGJQ0m-OCrKo1kEZgGdK7KVBHPL6B-zR1nBE2UQrFq-"
        "P7n8uyc-WBUQrGWHGam2t7-J3KBvMfMsXowtzMJjD4kB9wb-0qFJKmuZp1N6L-VJpGggN4xkaZnl49sQgCaN734fxFn6jSQHqO8cC6uAHjHyUuFCNkNGUOa8_"
        "9QUsATIpnSLOzJ0xmn-p03Z562AHAKbpcESbRWOGYK_WJGWGt-ZVpcugIdGIsqBg2rGmsaRp7RjWo4aie_"
        "Z2WOUmkoKG0JYjvRzcCe8SIgZIaG7uxJQ6NCZoF3sH4wab4ZAT0OGdHXal1NvJvUCgTnAc5FQjkCzBpmd29-OcbH3Yuy0hYcV5rhjkV_"
        "Mfr7IBNnkUVyn63HdYC444mRvPAZt6SLpAN7bhXVpi1h3Ys-"
        "AvT7Rk06x22mad8syiUuywm3ljEmiNGbzjPIO3ZshlH6v5yTpxfmdaFk3tdGy2iOKZiNgTd3u0xCyRQscb-0X4DjROBOsYCuBIx-jDBB8-j2-jzh3Z-"
        "zB7KasmA8iytawtIwuI9diiVhhws2lcwsF6s0Hp8-9f3ah2E1zJ_NzzQEo5SV9GO6AcgwsshRYDSziQBwl678VxqmO7VlecOi_rCDTNpcd6t6iDO6NMXZ527jL5iCCyAd_"
        "5lr8RQ_VAkMRpa8O53TqQOSvDTCrIzWWOOwKKu6TE7tI1FYXLsqAWxFpq-KVAQwwMCjpgCj_IShelhU8yukAdy2zCcC0Zr_3iP7Jd-dihdu_"
        "XvT0t78tzKXaoPRDidbF3vBN6JTTIhUJbH1TeRt3wG1-9ho2ZAtyOJXkBmndozx64f7Dc6qd_1zT6zhJqLiE7c2tIRThlI-"
        "qg8AtUSmO4akVeYAZF9crcyfkM4aA2p6ePDm3cMh3Iuk8-gHEZed2UtiW_FYtAqIzwpFu1ReuHarx6RNO0Poakc1mNBg1nCEURRIEbLtidayjkvOpy2u0z4OmX_"
        "bEKBlUe7auzIaMcqGfe4M-O2oSsTaheQCvfJOaqlBKZIOX88OpEj_Uk-nsmU4Zvx7";

QFile *AlivcLivePlayerMainDlg::mLogFile = nullptr;
std::mutex AlivcLivePlayerMainDlg::mLogMutex;

AlivcLivePlayerMainDlg::AlivcLivePlayerMainDlg(QWidget *parent) : QDialog(parent)
{
    CoInitializeEx(NULL, COINIT_MULTITHREADED);
#ifdef ENABLE_LOG
    if (mLogFile == nullptr) {
        QString logFileName = QString("%1.log").arg(QTime::currentTime().toString());
        logFileName.replace(':', '_');
        mLogFile = new QFile(logFileName);
        mLogFile->open(QIODevice::WriteOnly | QIODevice::Text);
    }
#endif
    setWindowFlags(windowFlags() & ~Qt::WindowMinMaxButtonsHint | Qt::WindowMinMaxButtonsHint);
    setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint);
    setWindowState(Qt::WindowMaximized);
    InitLayout();
    InitEvent();
    InitLog();
    InitApsaraPlayer();
    //std::string buffer;
    //buffer.assign(verifyFileContent);
    //InitPrivateService(buffer.c_str(), buffer.length());
}

AlivcLivePlayerMainDlg::~AlivcLivePlayerMainDlg()
{
    if (mPlayerPtr) {
        mPlayerPtr->setLogCallback(nullptr, nullptr);
        mPlayerPtr->stop();
        AliPlayer::DestroyPlayer(mPlayerPtr);
        mPlayerPtr = nullptr;
    }
#ifdef ENABLE_LOG
    if (mLogFile) {
        mLogFile->close();
        delete mLogFile;
        mLogFile = nullptr;
    }
#endif
}

void AlivcLivePlayerMainDlg::LogToFile(const char *fmt, ...)
{

    QString text = QTime::currentTime().toString("hh:mm:ss.zzz");
    text += " ";
    va_list args;
    va_start(args, fmt);
    text += QString::vasprintf(fmt, args);
    va_end(args);
    if (!(text.endsWith("\n") || text.endsWith("\r"))) {
        text += "\n";
    }
    OutputDebugStringA(text.toLocal8Bit());
#ifdef ENABLE_LOG
    {
        std::lock_guard<std::mutex> lock_guard(mLogMutex);
        if (mLogFile) {
            mLogFile->write(text.toLocal8Bit());
        }
    }
#endif
}


void AlivcLivePlayerMainDlg::onPlayerEvent(AliPlayer *player, AVPEventType eventType)
{
    if (eventType == AVPEventPrepareDone) {
        emit SgnPreparedUI();
    } else if (eventType == AVPEventLoadingStart) {
        emit SgnLoadingChanged(true);
    } else if (eventType == AVPEventLoadingEnd) {
        emit SgnLoadingChanged(false);
    } else if (eventType == AVPEventFirstRenderedStart) {
        quint64 tickCount = ::GetTickCount64();
        emit SgnFirstRendered(tickCount);
    } else if (eventType == AVPEventSeekEnd) {
        quint64 tickCount = ::GetTickCount64();
        emit SgnSeekEnd(tickCount);
    }
}

void AlivcLivePlayerMainDlg::onPlayerEvent(AliPlayer *player, AVPEventWithString eventWithString, const char *description)
{
    if (EVENT_VIDEO_RENDER_INIT_ERROR == eventWithString) {
        QString str = QString::fromStdString(description);
        emit SgnErrorUI(str);
    } else if (EVENT_PLAYER_DEMUXER_TRACE_ID == eventWithString) {

    } else if (EVENT_PLAYER_DEMUXER_STARTUP_INFO == eventWithString) {
    } else if (EVENT_PLAYER_NETWORK_RETRY == eventWithString) {
        emit SgnErrorUI(QStringLiteral("网络错误"));
    }
}

void AlivcLivePlayerMainDlg::onError(AliPlayer *player, AVPErrorModel *errorModel)
{
    QString str = QString::fromStdString(errorModel->message);
    emit SgnErrorUI(str);
}

void AlivcLivePlayerMainDlg::onVideoSizeChanged(AliPlayer *player, int width, int height, int rotation)
{}

void AlivcLivePlayerMainDlg::onCurrentPositionUpdate(AliPlayer *player, int64_t position)
{
    SetThreadExecutionState(ES_CONTINUOUS | ES_SYSTEM_REQUIRED | ES_DISPLAY_REQUIRED);
    emit SgnProgressUI(position);
}

void AlivcLivePlayerMainDlg::onBufferedPositionUpdate(AliPlayer *player, int64_t position)
{
    emit SgnUpdateBuffer(position);
}

void AlivcLivePlayerMainDlg::onLoadingProgress(AliPlayer *player, float progress)
{}


void AlivcLivePlayerMainDlg::onTrackReady(AliPlayer *player, AVPTrackInfo *info[], int count)
{
    if (count < 0) {
        return;
    }

    emit SgnUpdateDefinition();
}


void AlivcLivePlayerMainDlg::onTrackChanged(AliPlayer *player, AVPTrackInfo *info)
{
    if (mAudioRender) {
        mAudioRender->clearQueue();
    }
}

void AlivcLivePlayerMainDlg::onSubtitleExtAdded(AliPlayer *player, int64_t trackIndex, const char *URL)
{
    emit SgnAddExtSubtitle((qint64) trackIndex);
}

void AlivcLivePlayerMainDlg::onSubtitleShow(AliPlayer *player, int64_t trackIndex, int64_t subtitleId, const char *subtitle)
{
    emit SgnUpdateSubtitle(QString::fromStdString(subtitle), true);
}


void AlivcLivePlayerMainDlg::onSubtitleHide(AliPlayer *player, int64_t trackIndex, int64_t subtitleId)
{
    emit SgnUpdateSubtitle(QString(""), false);
}


void AlivcLivePlayerMainDlg::onGetThumbnailSuc(int64_t positionMs, int64_t fromPos, int64_t toPos, void *image)
{}

void AlivcLivePlayerMainDlg::onGetThumbnailFailed(int64_t positionMs)
{}

void AlivcLivePlayerMainDlg::onSnapshotImageBuffer(AliPlayer *player, int width, int height, unsigned char *pARGBBuffer)
{
    if (mSnapshotFolder.isEmpty()) {
        return;
    }
    QString savePath = QString("%1/%2.png").arg(mSnapshotFolder).arg(player->getMasterClockPts());
    QImage snapshot(pARGBBuffer, width, height, QImage::Format_ARGB32);
    snapshot.save(savePath);
}

void AlivcLivePlayerMainDlg::onPlayerStatusChanged(AliPlayer *player, AVPStatus oldStatus, AVPStatus newStatus)
{
    mPlayerStatus = newStatus;

    emit SgnStatusUI();

    switch (newStatus) {
        case AVPStatusStopped:
            emit SgnStopUI();
            break;
        case AVPStatusPaused:
            emit SgnPauseUI();
            break;
        case AVPStatusStarted:
            emit SgnResumeUI();
            break;
        default:
            break;
    }
}

void AlivcLivePlayerMainDlg::InitLayout()
{
    mPlayerViewPtr = new QWidget(this);
    QSizePolicy sizePolicy = mPlayerViewPtr->sizePolicy();
    sizePolicy.setHorizontalPolicy(QSizePolicy::Expanding);
    sizePolicy.setVerticalPolicy(QSizePolicy::Expanding);
    mPlayerViewPtr->setSizePolicy(sizePolicy);
    mPlayerViewPtr->setStyleSheet("background-color:black;");

    mAppRenderViewPtr = new QWidget(this);
    QSizePolicy sizePolicy2 = mAppRenderViewPtr->sizePolicy();
    sizePolicy2.setHorizontalPolicy(QSizePolicy::Expanding);
    sizePolicy2.setVerticalPolicy(QSizePolicy::Expanding);
    mAppRenderViewPtr->setSizePolicy(sizePolicy2);
    mAppRenderViewPtr->setStyleSheet("background-color:black;");
    mAppRenderViewPtr->setVisible(false);

    QHBoxLayout *topLayout = new QHBoxLayout();
    topLayout->setSpacing(2);
    topLayout->setMargin(0);
    topLayout->addWidget(mPlayerViewPtr);
    topLayout->addWidget(mAppRenderViewPtr);

    mStatsWraper = new QWidget();
    QHBoxLayout *statsLayout = new QHBoxLayout();
    statsLayout->setSpacing(0);
    statsLayout->setContentsMargins(20, 0, 20, 10);
    mStatisticsPtr = new QLabel(QStringLiteral("耗时:"));
    mStatisticsPtr->setStyleSheet("color:black; font-size:12px;font-weight:400;");
    mStatisticsPtr->setMaximumHeight(30);
    mStatusPtr = new QLabel(QStringLiteral("播放状态:"));
    mStatusPtr->setStyleSheet("color:black; font-size:12px;font-weight:400;");
    mStatusPtr->setMaximumHeight(30);
    mLabelLoading = new QLabel(QStringLiteral("loading"));
    mLabelLoading->setStyleSheet("color:red; font-size:12px;font-weight:400;");
    mLabelLoading->setMaximumHeight(30);
    mLabelLoading->setVisible(false);
    statsLayout->addWidget(mStatisticsPtr);
    statsLayout->addStretch();
    statsLayout->addWidget(mLabelLoading);
    statsLayout->addWidget(mStatusPtr);
    mStatsWraper->setLayout(statsLayout);
    sizePolicy = mStatsWraper->sizePolicy();
    sizePolicy.setHorizontalPolicy(QSizePolicy::Expanding);
    sizePolicy.setVerticalPolicy(QSizePolicy::Minimum);
    mStatsWraper->setSizePolicy(sizePolicy);

    mPrgressWraper = new QWidget();
    mPlayerProgress = new AlivcPlayerProgress(this);
    mPlayerProgress->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Minimum);
    mPlayerProgress->SetRange(0, 100);
    mPlayerProgress->SetPosition(0);
    mProgressLabel = new QLabel(QStringLiteral("--:--:--/--:--:--"));
    QHBoxLayout *progressLayout = new QHBoxLayout();
    progressLayout->setSpacing(10);
    progressLayout->setContentsMargins(20, 0, 20, 10);
    progressLayout->addWidget(mProgressLabel);
    progressLayout->addWidget(mPlayerProgress);
    mPrgressWraper->setLayout(progressLayout);
    sizePolicy = mPrgressWraper->sizePolicy();
    sizePolicy.setHorizontalPolicy(QSizePolicy::Expanding);
    sizePolicy.setVerticalPolicy(QSizePolicy::Minimum);
    mPrgressWraper->setSizePolicy(sizePolicy);

    mPlaySourceWraper = new QWidget();
    QHBoxLayout *playSourceLayout = new QHBoxLayout();
    mPlayByUrl = new QRadioButton(QStringLiteral("Url播放"));
    mPlayByVid = new QRadioButton(QStringLiteral("Vid播放"));
    mPlayByUrl->setChecked(true);
    playSourceLayout->addWidget(mPlayByUrl);
    playSourceLayout->addWidget(mPlayByVid);
    mBtnSts = new QPushButton(QStringLiteral("输入sts"));
    mBtnPlayAuth = new QPushButton(QStringLiteral("输入play auth"));
    mBtnMps = new QPushButton(QStringLiteral("输入mps"));
    mBtnEncryptData = new QPushButton(QStringLiteral("设置校验文件"));
    mBtnResetPlayer = new QPushButton(QStringLiteral("重置播放器"));
    mBtnNewInstance = new QPushButton(QStringLiteral("新实例"));
    playSourceLayout->addWidget(mBtnSts);
    playSourceLayout->addWidget(mBtnPlayAuth);
    playSourceLayout->addWidget(mBtnMps);
    playSourceLayout->addWidget(mBtnEncryptData);
    playSourceLayout->addWidget(mBtnResetPlayer);
    playSourceLayout->addWidget(mBtnNewInstance);
    playSourceLayout->addStretch();
    mPlaySourceWraper->setLayout(playSourceLayout);

    mUrlEditWraper = new QWidget();
    mPlaySouceLabel = new QLabel(QStringLiteral("播放地址"));
    mPlayerSourceEdit = new QLineEdit(DEFAULT_PLAY_URL);
    QHBoxLayout *urlEditLayout = new QHBoxLayout();
    urlEditLayout->setSpacing(10);
    urlEditLayout->setContentsMargins(20, 0, 20, 10);
    urlEditLayout->addWidget(mPlaySouceLabel);
    urlEditLayout->addWidget(mPlayerSourceEdit);
    mUrlEditWraper->setLayout(urlEditLayout);
    sizePolicy = mUrlEditWraper->sizePolicy();
    sizePolicy.setHorizontalPolicy(QSizePolicy::Expanding);
    sizePolicy.setVerticalPolicy(QSizePolicy::Minimum);
    mUrlEditWraper->setSizePolicy(sizePolicy);
    mSourceChosenPtr = new QPushButton(QStringLiteral("地址"));
    urlEditLayout->addWidget(mSourceChosenPtr);
    mConfigButton = new QPushButton(QStringLiteral("配置"));
    urlEditLayout->addWidget(mConfigButton);
    mBtnCacheConfig = new QPushButton(QStringLiteral("缓存配置"));
    urlEditLayout->addWidget(mBtnCacheConfig);
    mBtnPlayConfig = new QPushButton(QStringLiteral("PlayConfig"));
    urlEditLayout->addWidget(mBtnPlayConfig);
    mBtnDownloadDlg = new QPushButton(QStringLiteral("下载"));
    urlEditLayout->addWidget(mBtnDownloadDlg);

    mPrepareButtonPtr = new QPushButton(QStringLiteral("准备"));
    mPlayerButtonPtr = new QPushButton(QStringLiteral("播放"));
    mPlayerButtonPtr->setEnabled(false);
    mStopButtonPtr = new QPushButton(QStringLiteral("停止"));
    mStopButtonPtr->setEnabled(false);
    mPauseButtonPtr = new QPushButton(QStringLiteral("暂停"));
    mPauseButtonPtr->setEnabled(false);
    mResumtButtonPtr = new QPushButton(QStringLiteral("恢复"));
    mResumtButtonPtr->setEnabled(false);
    mFullScreenButtonPtr = new QPushButton(QStringLiteral("全屏"));
    mBtnSnapshot = new QPushButton(QStringLiteral("截图"));
    mMuteCheckbox = new QCheckBox(QStringLiteral("静音"));
    mAutoPlayCheckbox = new QCheckBox(QStringLiteral("自动播放"));
    //mAutoABRCheckbox = new QCheckBox(QStringLiteral("自动码率"));
    mLoopCheckbox = new QCheckBox(QStringLiteral("循环"));
    mAccurateSeekCheckbox = new QCheckBox(QStringLiteral("精确seek"));
    mCheckboxRightRender = new QCheckBox(QStringLiteral("右侧渲染"));
    mCheckboxAppRender = new QCheckBox(QStringLiteral("App渲染"));
    mLabelAppAudioDevice = new QLabel(QStringLiteral("App音频设备："));
    mComboAppAudioDevice = new QComboBox();
    mVolumeLabel = new QLabel(QStringLiteral("音量"));
    mVolumeSlider = new QSlider(Qt::Orientation::Horizontal);
    mVolumeSlider->setRange(0, 200);
    mVolumeSlider->setSingleStep(1);
    mVolumeSlider->setSliderPosition(100);
    mScalingModeCombox = new QComboBox();
    mScalingModeCombox->addItems(ScallingMode);
    mMirrorModeCombox = new QComboBox();
    mMirrorModeCombox->addItems(MirrorMode);
    mRotateModeCombox = new QComboBox();
    mRotateModeCombox->addItems(RotateMode);
    mRateCombox = new QComboBox();
    mRateCombox->addItems(RateMode);
    QLabel *definitionLabel = new QLabel(QStringLiteral("Track选择"));
    mDefinitionCombox = new QComboBox();
    mDefinitionCombox->setMinimumContentsLength(8);
    mDefinitionCombox->setSizeAdjustPolicy(QComboBox::AdjustToContents);
    mAudioTrackCombox = new QComboBox();
    mSubtitleTrackCombox = new QComboBox();
    mBtnAddExtSubtitle = new QPushButton(QStringLiteral("添加外挂字幕"));
    mExtSubtitleCombox = new QComboBox();

    mButtonWraper = new QWidget();
    QHBoxLayout *buttonBox = new QHBoxLayout();
    buttonBox->setSpacing(10);
    buttonBox->setContentsMargins(20, 0, 20, 10);
    buttonBox->addStretch();
    buttonBox->addWidget(mPrepareButtonPtr);
    buttonBox->addWidget(mPlayerButtonPtr);
    buttonBox->addWidget(mStopButtonPtr);
    buttonBox->addWidget(mPauseButtonPtr);
    buttonBox->addWidget(mResumtButtonPtr);
    buttonBox->addWidget(mFullScreenButtonPtr);
    buttonBox->addWidget(mBtnSnapshot);
    buttonBox->addWidget(mMuteCheckbox);
    buttonBox->addWidget(mAutoPlayCheckbox);
    buttonBox->addWidget(mLoopCheckbox);
    buttonBox->addWidget(mAccurateSeekCheckbox);
    //buttonBox->addWidget(mAutoABRCheckbox);
    playSourceLayout->addWidget(mCheckboxRightRender);
    playSourceLayout->addWidget(mCheckboxAppRender);
    playSourceLayout->addWidget(mLabelAppAudioDevice);
    playSourceLayout->addWidget(mComboAppAudioDevice);
    playSourceLayout->addWidget(mVolumeLabel);
    playSourceLayout->addWidget(mVolumeSlider);
    buttonBox->addWidget(mScalingModeCombox);
    buttonBox->addWidget(mMirrorModeCombox);
    buttonBox->addWidget(mRotateModeCombox);
    buttonBox->addWidget(mRateCombox);
    buttonBox->addWidget(definitionLabel);
    buttonBox->addWidget(mDefinitionCombox);
    buttonBox->addWidget(mAudioTrackCombox);
    buttonBox->addWidget(mSubtitleTrackCombox);
    buttonBox->addWidget(mBtnAddExtSubtitle);
    buttonBox->addWidget(mExtSubtitleCombox);
    mDefinitionCombox->setDisabled(true);
    mAudioTrackCombox->setDisabled(true);
    mSubtitleTrackCombox->setDisabled(true);
    mExtSubtitleCombox->insertItem(0, QStringLiteral("外挂字幕"), -1);
    mExtSubtitleCombox->setDisabled(true);
    buttonBox->addStretch();
    buttonBox->setAlignment(Qt::AlignVCenter);
    mButtonWraper->setLayout(buttonBox);
    sizePolicy = mButtonWraper->sizePolicy();
    sizePolicy.setHorizontalPolicy(QSizePolicy::Expanding);
    sizePolicy.setVerticalPolicy(QSizePolicy::Minimum);
    mButtonWraper->setSizePolicy(sizePolicy);

    QVBoxLayout *mainLayout = new QVBoxLayout();
    mainLayout->setSpacing(0);
    mainLayout->setMargin(0);
    mainLayout->addLayout(topLayout);
    //mainLayout->addSpacing(10);
    mainLayout->addWidget(mPlaySourceWraper);
    mainLayout->addWidget(mUrlEditWraper);
    mainLayout->addWidget(mPrgressWraper);
    mainLayout->addWidget(mButtonWraper);
    mainLayout->addWidget(mStatsWraper);
    mPlayerViewPtr->installEventFilter(this);
    setLayout(mainLayout);

    mSubtitleLabelPtr = new QLabel(QString(QStringLiteral("")), this);
    mSubtitleLabelPtr->setStyleSheet("color:black;background-color:gray;font-size:16px;font-weight:400;");
    //mSubtitleLabelPtr->setMaximumHeight(20);
    mSubtitleLabelPtr->setFixedSize(QSize(300, 50));
    mSubtitleLabelPtr->setParent(this);
    mSubtitleLabelPtr->raise();
    mSubtitleLabelPtr->hide();
    mPlayerViewPtr->stackUnder(mSubtitleLabelPtr);
}

bool AlivcLivePlayerMainDlg::InitEvent()
{
    bool ret = true;
    ret = connect(this, SIGNAL(SgnErrorUI(QString)), this, SLOT(OnErrorUI(QString)));
    ret = connect(this, SIGNAL(SgnUpdateUI()), this, SLOT(OnUpdateUI()));
    ret = connect(this, SIGNAL(SgnPreparedUI()), this, SLOT(OnPrearedUI()));
    ret = connect(this, SIGNAL(SgnCompletionUI()), this, SLOT(OnCompletionUI()));
    ret = connect(this, SIGNAL(SgnStopUI()), this, SLOT(OnStopUI()));
    ret = connect(this, SIGNAL(SgnPauseUI()), this, SLOT(OnPauseUI()));
    ret = connect(this, SIGNAL(SgnResumeUI()), this, SLOT(OnResumeUI()));
    ret = connect(this, SIGNAL(SgnStatusUI()), this, SLOT(OnStatusUI()));
    ret = connect(this, SIGNAL(SgnProgressUI(qint64)), this, SLOT(OnProgressUI(qint64)));
    ret = connect(mSourceChosenPtr, SIGNAL(clicked(bool)), this, SLOT(OnPathButtonClicked(bool)));
    ret = connect(mConfigButton, SIGNAL(clicked(bool)), this, SLOT(OnConfigButtonClicked(bool)));
    ret = connect(mBtnCacheConfig, SIGNAL(clicked(bool)), this, SLOT(OnBtnCacheConfigClicked(bool)));
    ret = connect(mBtnPlayConfig, SIGNAL(clicked(bool)), this, SLOT(OnBtnPlayConfigClicked(bool)));
    ret = connect(mBtnDownloadDlg, SIGNAL(clicked(bool)), this, SLOT(OnBtnDownloadDlgClicked(bool)));
    ret = connect(mPlayerButtonPtr, SIGNAL(clicked(bool)), this, SLOT(OnPlayButtonClicked(bool)));
    ret = connect(mPrepareButtonPtr, SIGNAL(clicked(bool)), this, SLOT(OnPrepareButtonClicked(bool)));
    ret = connect(mStopButtonPtr, SIGNAL(clicked(bool)), this, SLOT(OnStopButtonClicked(bool)));
    ret = connect(mPauseButtonPtr, SIGNAL(clicked(bool)), this, SLOT(OnPauseButtonClicked(bool)));
    ret = connect(mResumtButtonPtr, SIGNAL(clicked(bool)), this, SLOT(OnResumeButtonClicked(bool)));
    ret = connect(mFullScreenButtonPtr, SIGNAL(clicked(bool)), this, SLOT(OnFullScreenButtonClicked(bool)));
    ret = connect(mBtnSnapshot, SIGNAL(clicked(bool)), this, SLOT(OnBtnSnapshotClicked(bool)));
    ret = connect(mBtnAddExtSubtitle, SIGNAL(clicked(bool)), this, SLOT(OnBtnAddExtSubtitleClicked(bool)));
    ret = connect(mMuteCheckbox, SIGNAL(stateChanged(int)), this, SLOT(OnMuteStateChanged(int)));
    ret = connect(mAutoPlayCheckbox, SIGNAL(stateChanged(int)), this, SLOT(OnAutoPlayStateChanged(int)));
    ret = connect(mLoopCheckbox, SIGNAL(stateChanged(int)), this, SLOT(OnLoopStateChanged(int)));
    ret = connect(mCheckboxAppRender, SIGNAL(stateChanged(int)), this, SLOT(OnAppRenderStateChanged(int)));
    ret = connect(mCheckboxRightRender, SIGNAL(stateChanged(int)), this, SLOT(OnRightRenderStateChanged(int)));
    //ret = connect(mAutoABRCheckbox, SIGNAL(stateChanged(int)), this, SLOT(OnAutoABRStateChanged(int)));
    ret = connect(mVolumeSlider, SIGNAL(valueChanged(int)), this, SLOT(OnVolumeChange(int)));
    ret = connect(this, &AlivcLivePlayerMainDlg::SgnFinish, this, &AlivcLivePlayerMainDlg::OnFinish);
    ret = connect(mPlayerProgress, &AlivcPlayerProgress::SgnPositionChange, this, &AlivcLivePlayerMainDlg::OnProgressValueChange);
    ret = connect(this, &AlivcLivePlayerMainDlg::SgnUpdateBuffer, this, &AlivcLivePlayerMainDlg::OnUpdateBuffer);
    ret = connect(mPlayByUrl, &QRadioButton::clicked, this, &AlivcLivePlayerMainDlg::OnPlayByUrlButtonClicked);
    ret = connect(mPlayByVid, &QRadioButton::clicked, this, &AlivcLivePlayerMainDlg::OnPlayByVidButtonClicked);
    ret = connect(mBtnSts, &QPushButton::clicked, this, &AlivcLivePlayerMainDlg::OnStsButtonClicked);
    ret = connect(mBtnPlayAuth, &QPushButton::clicked, this, &AlivcLivePlayerMainDlg::OnPlayAuthButtonClicked);
    ret = connect(mBtnMps, &QPushButton::clicked, this, &AlivcLivePlayerMainDlg::OnMpsButtonClicked);
    ret = connect(mBtnEncryptData, &QPushButton::clicked, this, &AlivcLivePlayerMainDlg::OnEncryptDataButtonClicked);
    ret = connect(mBtnResetPlayer, &QPushButton::clicked, this, &AlivcLivePlayerMainDlg::OnResetPlayerButtonClicked);
    ret = connect(mBtnNewInstance, &QPushButton::clicked, this, &AlivcLivePlayerMainDlg::OnNewInstanceButtonClicked);
    ret = connect(mScalingModeCombox, SIGNAL(currentIndexChanged(int)), this, SLOT(OnScalingModeChanged(int)));
    ret = connect(mMirrorModeCombox, SIGNAL(currentIndexChanged(int)), this, SLOT(OnMirrorModeChanged(int)));
    ret = connect(mRotateModeCombox, SIGNAL(currentIndexChanged(int)), this, SLOT(OnRotateModeChanged(int)));
    ret = connect(mRateCombox, SIGNAL(currentIndexChanged(int)), this, SLOT(OnRateChanged(int)));
    ret = connect(this, &AlivcLivePlayerMainDlg::SgnUpdateDefinition, this, &AlivcLivePlayerMainDlg::OnUpdateDefinition);
    ret = connect(mDefinitionCombox, SIGNAL(currentIndexChanged(int)), this, SLOT(OnDefinitionChanged(int)));
    ret = connect(mAudioTrackCombox, SIGNAL(currentIndexChanged(int)), this, SLOT(OnAudioChanged(int)));
    ret = connect(mSubtitleTrackCombox, SIGNAL(currentIndexChanged(int)), this, SLOT(OnSubtitleChanged(int)));
    ret = connect(mExtSubtitleCombox, SIGNAL(currentIndexChanged(int)), this, SLOT(OnExtSubtitleChanged(int)));
    ret = connect(this, &AlivcLivePlayerMainDlg::SgnUpdateSubtitle, this, &AlivcLivePlayerMainDlg::onUpdateSuttile);
    ret = connect(this, &AlivcLivePlayerMainDlg::SgnAddExtSubtitle, this, &AlivcLivePlayerMainDlg::onExtSuttileAdded);
    ret = connect(this, SIGNAL(SgnLoadingChanged(bool)), this, SLOT(OnLoadingChanged(bool)));
    ret = connect(AlivcNotifyMgr::GetInstance(), &AlivcNotifyMgr::SgnPlayWithUrl, this, &AlivcLivePlayerMainDlg::OnPlayWithUrl);
    ret = connect(this, SIGNAL(SgnFirstRendered(quint64)), this, SLOT(OnFirstRendered(quint64)));
    ret = connect(this, SIGNAL(SgnSeekEnd(quint64)), this, SLOT(OnSeekEnd(quint64)));
    return ret;
}

bool AlivcLivePlayerMainDlg::eventFilter(QObject *widget, QEvent *event)
{
    if (widget == this && event->type() == QEvent::KeyPress) {
        QKeyEvent *keyEvent = static_cast<QKeyEvent *>(event);
        if (keyEvent->key() == Qt::Key_Escape && mFullScreen) {
            ChangeFullScreenState();
        }
        return true;
    } else if (widget == mPlayerViewPtr && (event->type() == QEvent::Resize)) {
        QPoint pt = mPlayerViewPtr->pos();
        QWidget *parent = (QWidget *) (mPlayerViewPtr->parent());
        QPoint pt1 = parent->mapToParent(pt);
        int width = mPlayerViewPtr->width();
        QPoint ptFps(pt1.x() + width / 2 - 100, pt1.y() + mPlayerViewPtr->height() - 50);
        mSubtitleLabelPtr->move(parent->mapFromParent(ptFps));
        return true;
    } else if (widget == mPlayerViewPtr && event->type() == QEvent::MouseButtonDblClick) {
        ChangeFullScreenState();
        return true;
    }

    return QWidget::eventFilter(widget, event);
}

void AlivcLivePlayerMainDlg::OnMuteStateChanged(int state)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnMuteStateChanged, state=%d", state);
    bool bMute = (state == 0 ? false : true);
    if (mPlayerPtr) {
        mPlayerPtr->setMute(bMute);
    }
    if (mAudioRender) {
        mAudioRender->setMute(bMute);
    }
}


void AlivcLivePlayerMainDlg::OnAutoPlayStateChanged(int state)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnAutoPlayStateChanged, state=%d", state);
    if (mPlayerPtr) {
        mPlayerPtr->setAutoPlay(state == 0 ? false : true);
    }
}

void AlivcLivePlayerMainDlg::OnLoopStateChanged(int state)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnLoopStateChanged, state=%d", state);
    if (mPlayerPtr) {
        mPlayerPtr->setLoop(state == 0 ? false : true);
    }
}

enum AVSampleFormat {
    AV_SAMPLE_FMT_NONE = -1,
    AV_SAMPLE_FMT_U8, ///< unsigned 8 bits
    AV_SAMPLE_FMT_S16,///< signed 16 bits
    AV_SAMPLE_FMT_S32,///< signed 32 bits
    AV_SAMPLE_FMT_FLT,///< float
    AV_SAMPLE_FMT_DBL,///< double

    AV_SAMPLE_FMT_U8P, ///< unsigned 8 bits, planar
    AV_SAMPLE_FMT_S16P,///< signed 16 bits, planar
    AV_SAMPLE_FMT_S32P,///< signed 32 bits, planar
    AV_SAMPLE_FMT_FLTP,///< float, planar
    AV_SAMPLE_FMT_DBLP,///< double, planar
    AV_SAMPLE_FMT_S64, ///< signed 64 bits
    AV_SAMPLE_FMT_S64P,///< signed 64 bits, planar

    AV_SAMPLE_FMT_NB///< Number of sample formats. DO NOT USE if linking dynamically
};

typedef struct SampleFmtInfo {
    char name[8];
    int bits;
    int planar;
    enum AVSampleFormat altform;///< planar<->packed alternative form
} SampleFmtInfo;

static SampleFmtInfo sample_fmt_info[AV_SAMPLE_FMT_NB];

int av_get_bytes_per_sample(enum AVSampleFormat sample_fmt)
{
    sample_fmt_info[AV_SAMPLE_FMT_U8] = {"u8", 8, 0, AV_SAMPLE_FMT_U8P};
    sample_fmt_info[AV_SAMPLE_FMT_S16] = {"s16", 16, 0, AV_SAMPLE_FMT_S16P};
    sample_fmt_info[AV_SAMPLE_FMT_S32] = {"s32", 32, 0, AV_SAMPLE_FMT_S32P};
    sample_fmt_info[AV_SAMPLE_FMT_S64] = {"s64", 64, 0, AV_SAMPLE_FMT_S64P};
    sample_fmt_info[AV_SAMPLE_FMT_FLT] = {"flt", 32, 0, AV_SAMPLE_FMT_FLTP};
    sample_fmt_info[AV_SAMPLE_FMT_DBL] = {"dbl", 64, 0, AV_SAMPLE_FMT_DBLP};
    sample_fmt_info[AV_SAMPLE_FMT_U8P] = {"u8p", 8, 1, AV_SAMPLE_FMT_U8};
    sample_fmt_info[AV_SAMPLE_FMT_S16P] = {"s16p", 16, 1, AV_SAMPLE_FMT_S16};
    sample_fmt_info[AV_SAMPLE_FMT_S32P] = {"s32p", 32, 1, AV_SAMPLE_FMT_S32};
    sample_fmt_info[AV_SAMPLE_FMT_S64P] = {"s64p", 64, 1, AV_SAMPLE_FMT_S64};
    sample_fmt_info[AV_SAMPLE_FMT_FLTP] = {"fltp", 32, 1, AV_SAMPLE_FMT_FLT};
    sample_fmt_info[AV_SAMPLE_FMT_DBLP] = {"dblp", 64, 1, AV_SAMPLE_FMT_DBL};
    return sample_fmt_info[sample_fmt].bits >> 3;
}

static bool OnAudioRendering(void *userData, int64_t pts, void *pcmData, int sampleRate, int nbSamples, int channels, int format)
{
    AlivcAudioRender *audioRender = (AlivcAudioRender *) userData;
    if (audioRender == nullptr) {
        return false;
    }
    int pcmDataLength = channels * av_get_bytes_per_sample((AVSampleFormat) format) * nbSamples;
    audioRender->renderData(pcmData, pcmDataLength, sampleRate, nbSamples, channels, format);
    return false;
}

void OnEventReport(void *userData, const char *jsonParams)
{
    AlivcLivePlayerMainDlg::LogToFile("[demo] OnEventReport %x %s", userData, jsonParams);
}

static bool OnVideoRendering(void *userData, int64_t pts, bool dropped, void **data, int *lineSize, int width, int height, int rotation,
                             AVPPixelFormat format)
{
    AlivcVideoRender *videoRender = (AlivcVideoRender *) userData;
    if (videoRender == nullptr || dropped) {
        return false;
    }
    videoRender->renderData(data, lineSize, width, height);
    return false;
}

bool AlivcLivePlayerMainDlg::OnRenderingFrame(void *userData, AVPFrameInfo *frameInfo)
{
    if (userData == nullptr || frameInfo == nullptr) {
        return false;
    }
    AlivcLivePlayerMainDlg *pSelf = (AlivcLivePlayerMainDlg *) userData;
    if (frameInfo->frameType == AVP_FrameType_Audio) {
        void *userData = pSelf->mAudioRender;
        int64_t pts = frameInfo->pts;
        int sampleRate = frameInfo->audio_sample_rate;
        int nbSamples = frameInfo->audio_nb_samples;
        int channels = frameInfo->audio_channels;
        int format = frameInfo->audio_format;

        //pcm data
        void *pcmData = malloc(frameInfo->audio_data_lineSize * frameInfo->audio_data_lineNum);
        int offset = 0;
        int sampleSize = frameInfo->audio_data_lineSize * frameInfo->audio_data_lineNum / frameInfo->audio_nb_samples / frameInfo->audio_channels;
        if (frameInfo->audio_data_lineNum != 1) {
            for (int i = 0; i < frameInfo->audio_nb_samples; i++) {
                for (int ch = 0; ch < frameInfo->audio_channels; ch++) {
                    memcpy((uint8_t*)pcmData + offset, frameInfo->audio_data[ch] + sampleSize * i, sampleSize);
                    offset += sampleSize;
                }
            }
        } else {
            memcpy(pcmData, frameInfo->audio_data[0], frameInfo->audio_data_lineSize * frameInfo->audio_data_lineNum);
        }

        bool ret = OnAudioRendering(userData, pts, pcmData, sampleRate, nbSamples, channels, format);
        free(pcmData);
        return ret;
    } else if (frameInfo->frameType == AVP_FrameType_Video) {
        void *userData = pSelf->mVideoRender;
        int64_t pts = frameInfo->pts;
        bool dropped = false;
        void **data = (void**)frameInfo->video_data_addr;
        int *lineSize = frameInfo->video_data_lineSize;
        int width = frameInfo->video_width;
        int height = frameInfo->video_height;
        int rotation = frameInfo->video_rotate;
        AVPPixelFormat format = frameInfo->video_format;
        return OnVideoRendering(userData, pts, dropped, data, lineSize, width, height, rotation, format);
    }
    return false;
}

void AlivcLivePlayerMainDlg::OnAppRenderStateChanged(int state)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnAppRenderStateChanged, state=%d", state);
    bool bAppRender = (state == 0 ? false : true);
    bool bRightRender = mCheckboxRightRender->isChecked();
    mAppRenderViewPtr->setVisible(bAppRender || bRightRender);
    if (mPlayerPtr == nullptr) {
        return;
    }
    if (bAppRender) {
        //init audio device combo box
        mComboAppAudioDevice->blockSignals(true);
        mComboAppAudioDevice->clear();
        SDL_Init(SDL_INIT_AUDIO);
        int deviceCount = SDL_GetNumAudioDevices(false);
        for (int i = 0; i < deviceCount; i++) {
            QString deviceName = QString::fromUtf8(SDL_GetAudioDeviceName(i, false));
            mComboAppAudioDevice->insertItem(i, deviceName);
        }
        SDL_QuitSubSystem(SDL_INIT_AUDIO);

        mAudioRender = new AlivcAudioRender();
        mAudioRender->setMute(mMuteCheckbox->isChecked());
        if (deviceCount >= 0) {
            mComboAppAudioDevice->setCurrentIndex(0);
            mAudioRender->setAudioDevice(0);
        }
        mComboAppAudioDevice->blockSignals(false);
        mVideoRender = new AlivcVideoRender((HWND) mAppRenderViewPtr->winId());
        //mPlayerPtr->setAudioRenderingCallback(OnAudioRendering, mAudioRender);
        //mPlayerPtr->setVideoRenderingCallback(OnVideoRendering, mVideoRender);
        mPlayerPtr->setRenderingFrameCallback(OnRenderingFrame, this);
    } else {
        //mPlayerPtr->setAudioRenderingCallback(nullptr, nullptr);
        //mPlayerPtr->setVideoRenderingCallback(nullptr, nullptr);
        mPlayerPtr->setRenderingFrameCallback(nullptr, nullptr);
        if (mAudioRender) {
            delete mAudioRender;
            mAudioRender = nullptr;
        }
        if (mVideoRender) {
            delete mVideoRender;
            mVideoRender = nullptr;
        }
    }
}

void AlivcLivePlayerMainDlg::OnRightRenderStateChanged(int state)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnRightRenderStateChanged, state=%d", state);
    bool bRightRender = (state == 0 ? false : true);
    bool bAppRender = mCheckboxAppRender->isChecked();
    mAppRenderViewPtr->setVisible(bAppRender || bRightRender);
}

void AlivcLivePlayerMainDlg::OnAutoABRStateChanged(int state)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnAutoABRStateChanged, state=%d", state);
    if (mPlayerPtr) {
        //mPlayerPtr->selectTrack
    }
}

void AlivcLivePlayerMainDlg::OnVolumeChange(int position)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnVolumeChange, position=%d", position);
    int volume = mVolumeSlider->value();
    mVolumeLabel->setText(QStringLiteral("音量%1%").arg(volume));
    ChangeVolume(volume);
}


void AlivcLivePlayerMainDlg::OnFinish(QString msg)
{
    QMessageBox::information(NULL, "Finish", msg, QMessageBox::Ok, QMessageBox::NoButton);
}


void AlivcLivePlayerMainDlg::OnPlayByUrlButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPlayByUrlButtonClicked");
    mPlaySourceType = AlivcPlaySourceUrlSource;
    UpdatePlaySource();
}


void AlivcLivePlayerMainDlg::OnPlayByVidButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPlayByVidButtonClicked");
    mPlaySourceType = AlivcPlaySourceVidSource;
    UpdatePlaySource();
}

void AlivcLivePlayerMainDlg::OnStsButtonClicked()
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnStsButtonClicked");
    AlivcPlayerStsDlg stsDlg(this);
    int ret = stsDlg.exec();
    if (ret == QDialog::Accepted) {
        mPlayStsInfo = stsDlg.GetStsInfo();
        mVidType = AlivcVidTypeSts;
        LogToFile("[demo] vid type change to sts");
    }
}

void AlivcLivePlayerMainDlg::OnPlayAuthButtonClicked()
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPlayAuthButtonClicked");
    QString vid = mPlayerSourceEdit->text();
    AlivcPlayerPlayAuthDlg authDlg(this, vid);
    int ret = authDlg.exec();
    if (ret == QDialog::Accepted) {
        mPlayAuthInfo = authDlg.GetPlayAuthInfo();
        mVidType = AlivcVidTypePlayAuth;
        mPlayerSourceEdit->setText(mPlayAuthInfo.vid);
        LogToFile("[demo] vid type change to playauth");
    }
}

void AlivcLivePlayerMainDlg::OnMpsButtonClicked()
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnMpsButtonClicked");
    AlivcPlayerMpsDlg mpsDlg(this);
    int ret = mpsDlg.exec();
    if (ret == QDialog::Accepted) {
        mPlayMpsInfo = mpsDlg.GetMpsInfo();
        mVidType = AlivcVidTypeMps;
        mPlayerSourceEdit->setText(mPlayMpsInfo.vid);
        LogToFile("[demo] vid type change to mps");
    }
}

void AlivcLivePlayerMainDlg::OnEncryptDataButtonClicked()
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnEncryptDataButtonClicked");
    QFileDialog *fileDialog = new QFileDialog(this);
    fileDialog->setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint & ~Qt::WindowMinMaxButtonsHint);
    fileDialog->setWindowTitle(tr("open"));
    fileDialog->setDirectory(".");
    fileDialog->setOption(QFileDialog::DontUseNativeDialog);
    fileDialog->setFileMode(QFileDialog::ExistingFiles);
    fileDialog->setViewMode(QFileDialog::Detail);
    QStringList fileNames;
    if (fileDialog->exec()) {
        fileNames = fileDialog->selectedFiles();
        QString encryptFilePath = fileNames.at(0);
        QFile file(encryptFilePath);
        file.open(QIODevice::ReadOnly | QIODevice::ExistingOnly);
        QByteArray encryptData = file.readAll();
        InitPrivateService(encryptData, encryptData.length());
        file.close();
        LogToFile("[demo] encrypt file:%s", encryptFilePath.toLocal8Bit().constData());
    }
    delete fileDialog;
}

void AlivcLivePlayerMainDlg::OnResetPlayerButtonClicked()
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnResetPlayerButtonClicked");
    if (mPlayerPtr) {
        mPlayerPtr->stop();
        AliPlayer::DestroyPlayer(mPlayerPtr);
        mPlayerPtr = nullptr;
    }
    ResetUI();
    InitApsaraPlayer();
}

void AlivcLivePlayerMainDlg::OnNewInstanceButtonClicked()
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnNewInstanceButtonClicked");
    AlivcLivePlayerMainDlg *playerDlg = new AlivcLivePlayerMainDlg;
    playerDlg->setMinimumSize(1200, 600);
    QDesktopWidget *deskdop = QApplication::desktop();
    playerDlg->move((deskdop->width() - playerDlg->width()) / 2, (deskdop->height() - playerDlg->height()) / 2);
    playerDlg->show();
}

void AlivcLivePlayerMainDlg::OnScalingModeChanged(int index)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnScalingModeChanged, index=%d", index);
    if (mPlayerPtr && index >= 0) {
        mPlayerPtr->setScalingMode((AVPScalingMode) index);
    }
}


void AlivcLivePlayerMainDlg::OnMirrorModeChanged(int index)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnMirrorModeChanged, index=%d", index);
    if (mPlayerPtr) {
        switch (index) {
            case 0:
                mPlayerPtr->setMirrorMode(AVP_MIRRORMODE_NONE);
                break;
            case 1:
                mPlayerPtr->setMirrorMode(AVP_MIRRORMODE_VERTICAL);
                break;
            case 2:
                mPlayerPtr->setMirrorMode(AVP_MIRRORMODE_HORIZONTAL);
                break;
            default:
                break;
        }
    }
}

void AlivcLivePlayerMainDlg::OnRotateModeChanged(int index)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnRotateModeChanged, index=%d", index);
    if (mPlayerPtr) {
        switch (index) {
            case 0:
                mPlayerPtr->setRotateMode(AVP_ROTATE_0);
                break;
            case 1:
                mPlayerPtr->setRotateMode(AVP_ROTATE_90);
                break;
            case 2:
                mPlayerPtr->setRotateMode(AVP_ROTATE_180);
                break;
            case 3:
                mPlayerPtr->setRotateMode(AVP_ROTATE_270);
                break;
            default:
                break;
        }
    }
}

void AlivcLivePlayerMainDlg::OnRateChanged(int index)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnRateChanged, index=%d", index);
    if (mPlayerPtr == nullptr || index < 0) {
        return;
    }
    float rate = (index + 1) * 0.5;
    mPlayerPtr->setRate(rate);
}

void AlivcLivePlayerMainDlg::onUpdateSuttile(QString text, bool show)
{
    if (show) {
        mSubtitleLabelPtr->show();
        mSubtitleLabelPtr->setText(text);
    } else {
        mSubtitleLabelPtr->hide();
    }
}

void AlivcLivePlayerMainDlg::onExtSuttileAdded(qint64 trackIndex)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::onExtSuttileAdded, trackIndex=%lld", trackIndex);
    if (trackIndex < 0) {
        QMessageBox::information(NULL, "Error", QStringLiteral("添加外挂字幕失败"), QMessageBox::Ok, QMessageBox::NoButton);
        return;
    }
    mExtSubtitleCombox->setEnabled(true);
    int count = mExtSubtitleCombox->count();
    for (int i = 1; i < count; i++) {
        QVariant q = mExtSubtitleCombox->itemData(i);
        int64_t existTrackIndex = q.toLongLong();
        if (existTrackIndex == trackIndex) {
            return;
        }
    }
    mExtSubtitleCombox->insertItem(count, QString::number(trackIndex), QVariant(trackIndex));
}

void AlivcLivePlayerMainDlg::OnUpdateDefinition()
{
    if (mPlayerPtr) {
        std::lock_guard<std::mutex> lock_guard(mTrackMutex);
        mDefinitionCombox->blockSignals(true);
        mDefinitionCombox->clear();
        mAudioTrackCombox->blockSignals(true);
        mAudioTrackCombox->clear();
        mSubtitleTrackCombox->blockSignals(true);
        mSubtitleTrackCombox->clear();

        AVPMediaInfo info = mPlayerPtr->getMediaInfo();
        for (int i = 0; i < info.trackCount; i++) {
            AVPTrackInfo *track = info.tracks[i];
            if (track->trackType == AVPTRACK_TYPE_VIDEO || track->trackType == AVPTRACK_TYPE_SAAS_VOD) {
                int index = mDefinitionCombox->count();
                mDefinitionCombox->insertItem(index, QString::fromStdString(track->trackDefinition));
                QVariant q(track->trackIndex);
                mDefinitionCombox->setItemData(index, q);
            } else if (track->trackType == AVPTRACK_TYPE_AUDIO) {
                int index = mAudioTrackCombox->count();
                mAudioTrackCombox->insertItem(index, QString::fromStdString(track->trackDefinition));
                QVariant q(track->trackIndex);
                mAudioTrackCombox->setItemData(index, q);
            } else if (track->trackType == AVPTRACK_TYPE_SUBTITLE) {
                int index = mSubtitleTrackCombox->count();
                mSubtitleTrackCombox->insertItem(index, QString::fromStdString(track->trackDefinition));
                QVariant q(track->trackIndex);
                mSubtitleTrackCombox->setItemData(index, q);
            }
        }

        AVPTrackInfo currentVideoTrack = mPlayerPtr->getCurrentTrack(AVPTRACK_TYPE_VIDEO);
        if (!currentVideoTrack.valid) {
            currentVideoTrack = mPlayerPtr->getCurrentTrack(AVPTRACK_TYPE_SAAS_VOD);
        }
        if (currentVideoTrack.valid) {
            int count = mDefinitionCombox->count();
            for (int i = 1; i < count; i++) {
                QVariant q = mDefinitionCombox->itemData(i);
                int trackIndex = q.toInt();
                if (trackIndex == currentVideoTrack.trackIndex) {
                    mDefinitionCombox->setCurrentIndex(i);
                    break;
                }
            }
        }

        AVPTrackInfo currentAudioTrack = mPlayerPtr->getCurrentTrack(AVPTRACK_TYPE_AUDIO);
        if (currentAudioTrack.valid) {
            int count = mAudioTrackCombox->count();
            for (int i = 1; i < count; i++) {
                QVariant q = mAudioTrackCombox->itemData(i);
                int trackIndex = q.toInt();
                if (trackIndex == currentAudioTrack.trackIndex) {
                    mAudioTrackCombox->setCurrentIndex(i);
                    break;
                }
            }
        }

        AVPTrackInfo currentSubtitleTrack = mPlayerPtr->getCurrentTrack(AVPTRACK_TYPE_SUBTITLE);
        if (currentAudioTrack.valid) {
            int count = mSubtitleTrackCombox->count();
            for (int i = 1; i < count; i++) {
                QVariant q = mSubtitleTrackCombox->itemData(i);
                int trackIndex = q.toInt();
                if (trackIndex == currentSubtitleTrack.trackIndex) {
                    mSubtitleTrackCombox->setCurrentIndex(i);
                    break;
                }
            }
        }
    }

    if (mDefinitionCombox->count() >= 2) {
        mDefinitionCombox->setEnabled(true);
    } else {
        mDefinitionCombox->setEnabled(false);
    }
    if (mAudioTrackCombox->count() > 1) {
        mAudioTrackCombox->setEnabled(true);
    } else {
        mAudioTrackCombox->setEditable(false);
    }
    if (mSubtitleTrackCombox->count() > 1) {
        mSubtitleTrackCombox->setEnabled(true);
    } else {
        mSubtitleTrackCombox->setEnabled(false);
    }

    mDefinitionCombox->blockSignals(false);
    mAudioTrackCombox->blockSignals(false);
    mSubtitleTrackCombox->blockSignals(false);
}

void AlivcLivePlayerMainDlg::OnAudioChanged(int index)
{
    if (mPlayerPtr && index >= 0) {
        QVariant q = mAudioTrackCombox->itemData(index);
        int trackIndex = q.toInt();
        mPlayerPtr->selectTrack(trackIndex);
    }
}

void AlivcLivePlayerMainDlg::OnSubtitleChanged(int index)
{
    if (mPlayerPtr && index >= 0) {
        QVariant q = mSubtitleTrackCombox->itemData(index);
        int trackIndex = q.toInt();
        mPlayerPtr->selectTrack(trackIndex);
    }
}

void AlivcLivePlayerMainDlg::OnExtSubtitleChanged(int index)
{
    if (mPlayerPtr && index >= 0) {
        mPlayerPtr->selectExtSubtitle(mLastExtSubtitleIndex, false);
        QVariant q = mExtSubtitleCombox->itemData(index);
        int64_t trackIndex = q.toLongLong();
        mLastExtSubtitleIndex = trackIndex;
        mPlayerPtr->selectExtSubtitle(mLastExtSubtitleIndex, true);
    }
}

void AlivcLivePlayerMainDlg::OnLoadingChanged(bool isLoading)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnLoadingChanged, isLoading=%d", (int) isLoading);
    mLabelLoading->setVisible(isLoading);
}

void AlivcLivePlayerMainDlg::OnPlayWithUrl(QString url)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPlayWithUrl, url=%s", url.toLocal8Bit().constData());
    OnStopButtonClicked(true);
    OnPlayByUrlButtonClicked(true);
    if (mPlayerSourceEdit) {
        mPlayerSourceEdit->setText(url);
    }
    if (mDownloaderDlg) {
        mDownloaderDlg->hide();
    }
}

void AlivcLivePlayerMainDlg::OnFirstRendered(quint64 tickCount)
{
    if (mLaunchTime == 0) {
        return;
    }
    quint64 duration = tickCount - mLaunchTime;
    QString cost = QStringLiteral("秒开:%1 ms").arg(duration);
    mStatisticsPtr->setText(cost);
    mLaunchTime = 0;
}

void AlivcLivePlayerMainDlg::OnSeekEnd(quint64 tickCount)
{
    if (mSeekTime == 0) {
        return;
    }
    quint64 duration = tickCount - mSeekTime;
    QString cost = QStringLiteral("seek耗时:%1 ms").arg(duration);
    mStatisticsPtr->setText(cost);
    mSeekTime = 0;
}

void AlivcLivePlayerMainDlg::OnDefinitionChanged(int index)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnDefinitionChanged, index=%d", index);
    if (mPlayerPtr && index >= 0) {
        QVariant q = mDefinitionCombox->itemData(index);
        int trackIndex = q.toInt();
        mPlayerPtr->selectTrack(trackIndex);
    }
}

void AlivcLivePlayerMainDlg::SeekTo(int pos)
{
    if (mPlayerPtr) {
        AVPSeekMode seekMode = mAccurateSeekCheckbox->isChecked() ? AVP_SEEKMODE_ACCURATE : AVP_SEEKMODE_INACCURATE;
        mSeekTime = ::GetTickCount64();
        mPlayerPtr->seekToTime((uint64_t)(pos), seekMode);
    }
}

void AlivcLivePlayerMainDlg::ChangeVolume(int volume)
{
    if (mPlayerPtr) {
        mPlayerPtr->setVolume(volume / 100.0);
    }
}

void AlivcLivePlayerMainDlg::logCallback(void *userData, int prio, char *buf)
{
    std::lock_guard<std::mutex> lock_guard(mLogMutex);
    QFile *logFile = (QFile *) userData;
    logFile->write(buf);
}

void AlivcLivePlayerMainDlg::InitLog()
{
    AliPlayer::enableLog(LOG_LEVEL_TRACE);
#ifdef ENABLE_LOG
    AliPlayer::setLogCallback(logCallback, mLogFile);
#endif
}

void AlivcLivePlayerMainDlg::InitApsaraPlayer()
{
    if (mPlayerPtr == nullptr) {
        mPlayerPtr = AliPlayer::CreatePlayer();
        mPlayerPtr->setListener(this);
        mPlayerPtr->setEventReprotCallback(OnEventReport, this);
        mPlayerPtr->setView((void *) mPlayerViewPtr->winId());

        mScalingModeCombox->blockSignals(true);
        mPlayerPtr->setScalingMode(AVP_SCALINGMODE_SCALEASPECTFIT);
        mScalingModeCombox->setCurrentIndex(mPlayerPtr->getScalingMode());
        mScalingModeCombox->blockSignals(false);

        mMirrorModeCombox->blockSignals(true);
        mMirrorModeCombox->setCurrentIndex(mPlayerPtr->getMirrorMode());
        mMirrorModeCombox->blockSignals(false);

        mRotateModeCombox->blockSignals(true);
        mRotateModeCombox->setCurrentIndex(mPlayerPtr->getRotateMode());
        mRotateModeCombox->blockSignals(false);

        float rate = mPlayerPtr->getRate();
        mRateCombox->blockSignals(true);
        mRateCombox->setCurrentIndex((rate / 0.5) - 1);
        mRateCombox->blockSignals(false);
    }
}

static QString FormatPosition(int64_t duration)
{
    int64_t h = duration / 3600;
    int m = (duration % 3600) / 60;
    int s = duration % 60;

    return QString("%0:%1:%2").arg(h).arg(m).arg(s);
}

void AlivcLivePlayerMainDlg::OnPrearedUI()
{
    if (mPlayerPtr) {
        int64_t duration = mPlayerPtr->getDuration();
        mPlayerProgress->SetRange(0, duration);
        mPlayerProgress->SetPosition(0);

        QString str = "00:00:00/";
        QString pos = FormatPosition(duration / 1000);

        mProgressLabel->setText(str + pos);

        mPrepareButtonPtr->setEnabled(false);
        //mPauseButtonPtr->setEnabled(true);
        mPlayerProgress->setEnabled(true);
        mStopButtonPtr->setEnabled(true);
        mCheckboxAppRender->setEnabled(false);
        mCheckboxRightRender->setEnabled(false);
        if (duration == 0) {
            mPlayerProgress->setEnabled(false);
        } else {
            mPlayerProgress->setEnabled(true);
        }
        QApplication::restoreOverrideCursor();
    }
}


void AlivcLivePlayerMainDlg::OnCompletionUI()
{
    QString playURL = mPlayerSourceEdit->text();
    QString strFinish = "play Finished";
    QString span = "\r\n";
    QString msg = playURL + span + strFinish;
    emit SgnFinish(span);
}

void AlivcLivePlayerMainDlg::UpdateStatus()
{
    QString str = "";
    switch (mPlayerStatus) {
        case AVPStatusIdle:
            str = QStringLiteral("播放状态:闲时");
            break;
        case AVPStatusInitialzed:
            str = QStringLiteral("播放状态:初始化完成");
            break;
        case AVPStatusPrepared:
            str = QStringLiteral("播放状态:正在准备");
            break;
        case AVPStatusStarted:
            str = QStringLiteral("播放状态:正在播放");
            break;
        case AVPStatusPaused:
            str = QStringLiteral("播放状态:播放暂停");
            break;
        case AVPStatusStopped:
            str = QStringLiteral("播放状态:播放停止");
            break;
        case AVPStatusCompletion:
            str = QStringLiteral("播放状态:播放完成");
            break;
        case AVPStatusError:
            str = QStringLiteral("播放状态:播放错误");
            break;
        default:
            break;
    }

    if (mPlayerPtr) {
        AVPTrackInfo videoInfo = mPlayerPtr->getCurrentTrack(AVPTRACK_TYPE_VIDEO);
        if (!videoInfo.valid) {
            videoInfo = mPlayerPtr->getCurrentTrack(AVPTRACK_TYPE_SAAS_VOD);
        }
        if (videoInfo.valid && videoInfo.trackDefinition) {
            str += QStringLiteral("，视频track：");
            str += QString::fromStdString(videoInfo.trackDefinition);
        }

        AVPTrackInfo audioInfo = mPlayerPtr->getCurrentTrack(AVPTRACK_TYPE_AUDIO);
        if (audioInfo.valid && audioInfo.trackDefinition) {
            str += QStringLiteral("，音频track：");
            str += QString::fromStdString(audioInfo.trackDefinition);
        }

        AVPTrackInfo subtitleInfo = mPlayerPtr->getCurrentTrack(AVPTRACK_TYPE_SUBTITLE);
        if (subtitleInfo.valid && subtitleInfo.trackDefinition) {
            str += QStringLiteral("，字幕track：");
            str += QString::fromStdString(subtitleInfo.trackDefinition);
        }

        str += QStringLiteral("，master clock：");
        char ptsCh[64] = {0};
        int64_t masterPts = mPlayerPtr->getMasterClockPts();
        sprintf(ptsCh, "%lld", masterPts);
        str += QString(ptsCh);
    }

    mStatusPtr->setText(str);
}


void AlivcLivePlayerMainDlg::UpdatePlaySource()
{
    if (mPlaySourceType == AlivcPlaySourceUrlSource) {
        mPlaySouceLabel->setText(QStringLiteral("播放地址"));
        mPlayerSourceEdit->clear();
        mSourceChosenPtr->setVisible(true);
        mSourceChosenPtr->setText(QStringLiteral("地址"));
        mPlayerButtonPtr->setText(QStringLiteral("播放"));
    } else if (mPlaySourceType == AlivcPlaySourceVidSource) {
        mPlaySouceLabel->setText(QStringLiteral("播放Vid"));
        mPlayerSourceEdit->clear();
        mSourceChosenPtr->setVisible(false);
        mSourceChosenPtr->setText(QStringLiteral("播放列表"));
        mDefinitionCombox->clear();
        mPlayerButtonPtr->setText(QStringLiteral("播放"));
    }
}

void AlivcLivePlayerMainDlg::ResetUI()
{
    OnStopUI();
    mMuteCheckbox->setChecked(false);
    mAutoPlayCheckbox->setChecked(false);
    mLoopCheckbox->setChecked(false);
    mAccurateSeekCheckbox->setChecked(false);
    mVolumeSlider->setSliderPosition(100);
}

void AlivcLivePlayerMainDlg::OnProgressUI(qint64 pos)
{
    if (mPlayerPtr) {
        if (mPlayerProgress->GetMaxValue() != (float) mPlayerPtr->getDuration()) {
            int64_t total_duration = mPlayerPtr->getDuration();
            mPlayerProgress->SetRange(0, total_duration);
            if (total_duration == 0) {
                mPlayerProgress->setEnabled(false);
            } else {
                mPlayerProgress->setEnabled(true);
            }
        }

        mPlayerProgress->SetPosition(pos);
        QString strPos = FormatPosition(pos / 1000);
        int duration = mPlayerPtr->getDuration() / 1000;
        QString strDur = FormatPosition(duration);

        mProgressLabel->setText(strPos + "/" + strDur);

        UpdateStatus();
    }
}

void AlivcLivePlayerMainDlg::OnUpdateBuffer(int pos)
{
    mPlayerProgress->SetBufferPosition(pos);
}

void AlivcLivePlayerMainDlg::OnProgressValueChange(float pos)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnProgressValueChange, pos=%f", pos);
    SeekTo(pos);
}


void AlivcLivePlayerMainDlg::OnErrorUI(QString errorMsg)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnErrorUI, errorMsg=%f", errorMsg.toLocal8Bit().constData());
    if (mPlayerPtr) {
        mPlayerPtr->stop();
    }

    //update player state
    QString strError = errorMsg;
    QMessageBox::information(NULL, "Error", strError, QMessageBox::Ok, QMessageBox::NoButton);

    mPrepareButtonPtr->setEnabled(true);
    mStopButtonPtr->setEnabled(false);
    mCheckboxAppRender->setEnabled(true);
    mCheckboxRightRender->setEnabled(true);
    mPauseButtonPtr->setEnabled(false);
    mResumtButtonPtr->setEnabled(false);
    mPlayerProgress->setEnabled(false);
    QApplication::restoreOverrideCursor();
}

void AlivcLivePlayerMainDlg::OnStatusUI()
{
    UpdateStatus();
}

void AlivcLivePlayerMainDlg::OnResumeUI()
{
    mPauseButtonPtr->setEnabled(true);
    mResumtButtonPtr->setEnabled(false);
    mPlayerButtonPtr->setEnabled(false);
}

void AlivcLivePlayerMainDlg::OnPauseUI()
{
    mPauseButtonPtr->setEnabled(false);
    mResumtButtonPtr->setEnabled(true);
}

void AlivcLivePlayerMainDlg::OnStopUI()
{
    mPlayerButtonPtr->setEnabled(false);
    mPrepareButtonPtr->setEnabled(true);
    mStopButtonPtr->setEnabled(false);
    mCheckboxAppRender->setEnabled(true);
    mCheckboxRightRender->setEnabled(true);
    mPauseButtonPtr->setEnabled(false);
    mResumtButtonPtr->setEnabled(false);
    mPlayerProgress->setEnabled(false);
    mPlayerProgress->SetPosition(0);
    mPlayerProgress->SetBufferPosition(0);
    mPlayerProgress->SetRange(0, 0);
    mLabelLoading->setVisible(false);
    int count = mExtSubtitleCombox->count();
    mExtSubtitleCombox->blockSignals(true);
    for (int i = count - 1; i > 0; i--) {
        mExtSubtitleCombox->removeItem(i);
    }
    mExtSubtitleCombox->setEnabled(false);
    mExtSubtitleCombox->blockSignals(false);
    mSubtitleLabelPtr->hide();
}

void AlivcLivePlayerMainDlg::OnUpdateUI()
{
    //update player state
}

void AlivcLivePlayerMainDlg::NotifySDKError(int error)
{
    QMessageBox::warning(this, QStringLiteral("错误"), QStringLiteral("SDK发生错误"), QMessageBox::Yes);
}

void AlivcLivePlayerMainDlg::OnPlayButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPlayButtonClicked");
    SetThreadExecutionState(ES_CONTINUOUS | ES_SYSTEM_REQUIRED | ES_DISPLAY_REQUIRED);
    if (mPlayerPtr) {
        mPlayerPtr->start();
        mPlayerButtonPtr->setEnabled(false);
        mPauseButtonPtr->setEnabled(true);
    }
}

void AlivcLivePlayerMainDlg::OnStopButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnStopButtonClicked");
    if (mPlayerPtr) {
        mPlayerPtr->stop();
        OnStopUI();
    }
    SetThreadExecutionState(ES_CONTINUOUS);
}

void AlivcLivePlayerMainDlg::OnPrepareButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPrepareButtonClicked");
    InitApsaraPlayer();
    if (mPlayerPtr == nullptr) {
        return;
    }

    if (mPlayerSourceEdit->text().isEmpty()) {
        QMessageBox::warning(this, QStringLiteral("错误"), QStringLiteral("播放信息为空"), QMessageBox::Yes);
        return;
    }

    if (mCheckboxAppRender->isChecked()) {
        mPlayerPtr->setView((void *) mPlayerViewPtr->winId());
        if (mAudioRender) {
            delete mAudioRender;
            mAudioRender = nullptr;
        }
        if (mVideoRender) {
            delete mVideoRender;
            mVideoRender = nullptr;
        }
        mAudioRender = new AlivcAudioRender();
        mAudioRender->setMute(mMuteCheckbox->isChecked());
        int index = mComboAppAudioDevice->currentIndex();
        if (index >= 0) {
            mAudioRender->setAudioDevice(index);
        }
        mVideoRender = new AlivcVideoRender((HWND) mAppRenderViewPtr->winId());
        //mPlayerPtr->setAudioRenderingCallback(OnAudioRendering, mAudioRender);
        //mPlayerPtr->setVideoRenderingCallback(OnVideoRendering, mVideoRender);
        mPlayerPtr->setRenderingFrameCallback(OnRenderingFrame, this);
    } else {
        if (mCheckboxRightRender->isChecked()) {
            mPlayerPtr->setView((void *) mAppRenderViewPtr->winId());
        } else {
            mPlayerPtr->setView((void *) mPlayerViewPtr->winId());
        }
    }

    mLaunchTime = ::GetTickCount64();
    if (mPlaySourceType == AlivcPlaySourceUrlSource) {
        QString playURL = mPlayerSourceEdit->text();
        AVPUrlSource urlSource;
        urlSource.setUrl(playURL.toStdString().c_str());

        mPlayerPtr->setSource(urlSource);
        mPlayerPtr->prepare();

        mPlayURL = playURL;
    } else if (mPlaySourceType == AlivcPlaySourceVidSource) {
        VidPlayerConfigGenerator playConfigGen;
        playConfigGen.setPreviewTime(mPlayConfig.previewTime);
        playConfigGen.setHlsUriToken(mPlayConfig.hlsToken.toLocal8Bit());
        const char *playConfig = playConfigGen.generatePlayerConfig();
        if (mVidType == AlivcVidTypeSts) {
            if (mPlayStsInfo.accessKeyId.isEmpty() || mPlayStsInfo.accessKeySecret.isEmpty() || mPlayStsInfo.securityToken.isEmpty()) {
                QMessageBox::warning(this, QStringLiteral("错误"), QStringLiteral("鉴权信息为空，请先输入sts"), QMessageBox::Yes);
                return;
            }
            QString playVid = mPlayerSourceEdit->text();
            AVPVidStsSource vidSource;
            vidSource.initWithVid(playVid.toLocal8Bit(), mPlayStsInfo.accessKeyId.toLocal8Bit(), mPlayStsInfo.accessKeySecret.toLocal8Bit(),
                                  mPlayStsInfo.securityToken.toLocal8Bit(), mPlayStsInfo.region.toLocal8Bit(), playConfig);
            mPlayerPtr->setSource(vidSource);
        } else if (mVidType == AlivcVidTypePlayAuth) {
            if (mPlayAuthInfo.vid.isEmpty() || mPlayAuthInfo.playAuth.isEmpty()) {
                QMessageBox::warning(this, QStringLiteral("错误"), QStringLiteral("鉴权信息为空，请先输入playAuth"), QMessageBox::Yes);
                return;
            }
            mPlayerSourceEdit->setText(mPlayAuthInfo.vid);
            AVPVidAuthSource authSource;
            authSource.initWithVid(mPlayAuthInfo.vid.toLocal8Bit(), mPlayAuthInfo.playAuth.toLocal8Bit(),
                                   mPlayAuthInfo.region.toLocal8Bit(), playConfig);
            mPlayerPtr->setSource(authSource);
        } else if (mVidType == AlivcVidTypeMps) {
            if (mPlayMpsInfo.accessKeyId.isEmpty() || mPlayMpsInfo.accessKeySecret.isEmpty() || mPlayMpsInfo.authInfo.isEmpty() ||
                mPlayMpsInfo.hlsUriToken.isEmpty() || mPlayMpsInfo.region.isEmpty() || mPlayMpsInfo.securityToken.isEmpty() ||
                mPlayMpsInfo.vid.isEmpty()) {

                QMessageBox::warning(this, QStringLiteral("错误"), QStringLiteral("鉴权信息为空，请先输入mps"), QMessageBox::Yes);
                return;
            }
            mPlayerSourceEdit->setText(mPlayMpsInfo.vid);
            AVPVidMpsSource mpsSource;
            mpsSource.initWithVid(mPlayMpsInfo.vid.toLocal8Bit(), mPlayMpsInfo.accessKeyId.toLocal8Bit(),
                                  mPlayMpsInfo.accessKeySecret.toLocal8Bit(), mPlayMpsInfo.securityToken.toLocal8Bit(),
                                  mPlayMpsInfo.authInfo.toLocal8Bit(), mPlayMpsInfo.region.toLocal8Bit(), "",
                                  mPlayMpsInfo.hlsUriToken.toLocal8Bit());
            mPlayerPtr->setSource(mpsSource);
        } else {
            assert(false);
        }
        AliPlayer::alivcFree((void *) playConfig);
        mPlayerPtr->prepare();
    }

    mPlayerButtonPtr->setEnabled(true);
    mPrepareButtonPtr->setEnabled(false);
    mStopButtonPtr->setEnabled(true);
    mCheckboxAppRender->setEnabled(false);
    mCheckboxRightRender->setEnabled(false);
}

void AlivcLivePlayerMainDlg::OnPathButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPathButtonClicked");
    if (mPlaySourceType == AlivcPlaySourceUrlSource) {
        QFileDialog *fileDialog = new QFileDialog(this);
        fileDialog->setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint & ~Qt::WindowMinMaxButtonsHint);
        fileDialog->setWindowTitle(tr("open"));
        fileDialog->setDirectory(".");
        fileDialog->setNameFilter(tr("Videos(*.mp4 *.flv *.m3u8)"));
        fileDialog->setOption(QFileDialog::DontUseNativeDialog);
        fileDialog->setFileMode(QFileDialog::ExistingFiles);
        fileDialog->setViewMode(QFileDialog::Detail);
        QStringList fileNames;
        if (fileDialog->exec()) {
            fileNames = fileDialog->selectedFiles();
            QString str = fileNames.at(0);
            mPlayerSourceEdit->setText(str);
        }
        delete fileDialog;
    } else if (mPlaySourceType == AlivcPlaySourceVidSource) {
        QDesktopWidget *deskdop = QApplication::desktop();
        int height = deskdop->height() / 4 * 3;
        int width = height / 4 * 3;
        int x = (deskdop->width() - width) / 2;
        int y = (deskdop->height() - height) / 2;

        AlivcPlayListDlg playListDlg(this);
        playListDlg.setGeometry(x, y, width, height);
        playListDlg.exec();
        QString vid = playListDlg.GetCurrentVideoId();
        mPlayerSourceEdit->setText(vid);
    }
}


void AlivcLivePlayerMainDlg::OnConfigButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnConfigButtonClicked");
    if (mPlayerPtr == nullptr) {
        return;
    }

    AVPConfig *pConfig = mPlayerPtr->getConfig();
    AlivcPlayerConfigDlg configDlg(this, pConfig);
    configDlg.setFixedSize(800, 600);
    int ret = configDlg.exec();
    if (ret == QDialog::Accepted) {
        AVPConfig config = configDlg.GetAvConfig();
        mPlayerPtr->setConfig(&config);
        LogToFile("[demo] apply config");
    }
}

void AlivcLivePlayerMainDlg::OnBtnCacheConfigClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnBtnCacheConfigClicked");
    if (mPlayerPtr == nullptr) {
        return;
    }
    AlivcPlayerCacheConfigDlg dlg(this);
    dlg.SetCacheConfig(mCacheConfig);
    int ret = dlg.exec();
    if (ret == QDialog::Accepted) {
        mCacheConfig = dlg.GetCacheConfig();
        mPlayerPtr->setCacheConfig(&mCacheConfig);
        LogToFile("[demo] apply cache config, enable=%d, maxDuration=%d, maxSizeMB=%d, path=%s", (int) mCacheConfig.enable,
                  mCacheConfig.maxDuration, mCacheConfig.maxSizeMB, mCacheConfig.path);
    }
}

void AlivcLivePlayerMainDlg::OnBtnPlayConfigClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnBtnPlayConfigClicked");
    if (mPlayerPtr == nullptr) {
        return;
    }
    AlivcPlayerPlayConfigDlg dlg(this);
    dlg.SetPlayConfig(mPlayConfig);
    int ret = dlg.exec();
    if (ret == QDialog::Accepted) {
        mPlayConfig = dlg.GetPlayConfig();
        LogToFile("[demo] set play config, hlsToken=%s, previewTime=%d", mPlayConfig.hlsToken.toLocal8Bit().constData(),
                  mPlayConfig.previewTime);
    }
}

void AlivcLivePlayerMainDlg::OnBtnDownloadDlgClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnBtnDownloadDlgClicked");
    if (mDownloaderDlg == nullptr) {
        mDownloaderDlg = new AlivcDownloaderDlg(this);
    }
    mDownloaderDlg->show();
}

void AlivcLivePlayerMainDlg::OnPlayListButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPlayListButtonClicked");
}

void AlivcLivePlayerMainDlg::OnPauseButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnPauseButtonClicked");
    if (mPlayerPtr) {
        mPlayerPtr->pause();
    }
}

void AlivcLivePlayerMainDlg::OnResumeButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnResumeButtonClicked");
    if (mPlayerPtr) {
        mPlayerPtr->start();
    }
}

void AlivcLivePlayerMainDlg::OnFullScreenButtonClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnFullScreenButtonClicked");
    ChangeFullScreenState();
}

void AlivcLivePlayerMainDlg::OnBtnSnapshotClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnBtnSnapshotClicked");
    if (mSnapshotFolder.isEmpty()) {
        mSnapshotFolder = QFileDialog::getExistingDirectory(this, QStringLiteral("选择保存目录"), "./",
                                                            QFileDialog::ShowDirsOnly | QFileDialog::DontUseNativeDialog);
        LogToFile("[demo] mSnapshotFolder=%s", mSnapshotFolder.toLocal8Bit().constData());
    }
    if (mPlayerPtr) {
        mPlayerPtr->snapshot();
    }
}

void AlivcLivePlayerMainDlg::OnBtnAddExtSubtitleClicked(bool checked)
{
    LogToFile("[demo] AlivcLivePlayerMainDlg::OnBtnAddExtSubtitleClicked");
    AlivcPlayerAddExtSubtitleDlg dlg(this);
    int ret = dlg.exec();
    if (ret == QDialog::Accepted) {
        QString extSubtitleUrl = dlg.GetExtSubtitleUrl();
        if (mPlayerPtr) {
            mPlayerPtr->addExtSubtitle(extSubtitleUrl.toLocal8Bit());
        }
        LogToFile("[demo] addExtSubtitle:%s", extSubtitleUrl.toLocal8Bit().constData());
    }
}

void AlivcLivePlayerMainDlg::keyPressEvent(QKeyEvent *event)
{
    switch (event->key()) {
        case Qt::Key_Escape:
            if (mFullScreen) {
                ChangeFullScreenState();
            }
            break;
        default:
            QWidget::keyPressEvent(event);
    }
}

void AlivcLivePlayerMainDlg::closeEvent(QCloseEvent *event)
{
    AliPlayer::enableLog(LOG_LEVEL_NONE);
#ifdef ENABLE_LOG
    AliPlayer::setLogCallback(nullptr, nullptr);
#endif
    if (mPlayerPtr) {
        mPlayerPtr->stop();
        AliPlayer::DestroyPlayer(mPlayerPtr);
        mPlayerPtr = nullptr;
    }
}

void AlivcLivePlayerMainDlg::ChangeFullScreenState()
{
    if (!mFullScreen) {
        mButtonWraper->hide();
        mStatsWraper->hide();
        mUrlEditWraper->hide();
        showFullScreen();
        mFullScreen = true;
        mPrgressWraper->hide();
    } else {
        showNormal();
        mButtonWraper->show();
        mStatsWraper->show();
        mUrlEditWraper->show();
        mFullScreen = false;
        mPrgressWraper->show();
    }
}