#include "AlivcPlayerProgress.h"
#include <QPainter>
#include <QMouseEvent>
#include <QDebug>

AlivcPlayerProgress::AlivcPlayerProgress(QWidget *parent)
    : QFrame(parent)
{
}

AlivcPlayerProgress::~AlivcPlayerProgress()
{
}

void AlivcPlayerProgress::SetRange(float minValue, float maxValue)
{
  mMaxValue = maxValue;
  mMinValue = minValue;
}

void AlivcPlayerProgress::SetPosition(float position)
{
    if (position < mMinValue) {
        position = mMinValue;
    }
    if (position > mMaxValue) {
        position = mMaxValue;
    }

    mPosition = position;
    update();
}

void AlivcPlayerProgress::SetBufferPosition(float bufferPosition)
{
    if (bufferPosition < mMinValue) {
        bufferPosition = mMinValue;
    }
    if (bufferPosition > mMaxValue) {
        bufferPosition = mMaxValue;
    }

    mBufferPostion = bufferPosition;
    update();
}

void AlivcPlayerProgress::paintEvent(QPaintEvent *)
{
  QPainter painter(this);

  //Ʊɫ
  QBrush backgroundBrush(QColor(234, 234, 234));
  painter.setBrush(backgroundBrush);
  painter.setPen(QColor(234, 234, 234));
  painter.drawRect(0, -5, width(), height());

  //ƻbuffer
  QBrush bufferBrush(QColor(195, 197, 197));
  painter.setBrush(bufferBrush);
  painter.setPen(QColor(195, 197, 197));
  float bufferPos = mBufferPostion / mMaxValue * width();
  painter.drawRect(0, -5, bufferPos, height());

  //ý
  QBrush brush(QColor(51, 170, 51));
  painter.setBrush(brush);
  painter.setPen(QColor(51, 170, 51));
  float pos = mPosition / mMaxValue * width();
  painter.drawRect(0, -5, pos, height());
}

void AlivcPlayerProgress::mouseReleaseEvent(QMouseEvent *event)
{
  if (event == nullptr)
  {
    return;
  }

  if (mMaxValue <= 0)
  {
    qDebug() << "duration is 0, can't seek";
    return;
  }

  int x = event->x();
  float x_pos = (float)x / (float)width() * mMaxValue;
  emit SgnPositionChange(x_pos);
}

void AlivcPlayerProgress::mouseDoubleClickEvent(QMouseEvent *event)
{
  if (event == nullptr)
  {
    return;
  }

  if (mMaxValue <= 0)
  {
    qDebug() << "duration is 0, can't seek";
    return;
  }

  int x = event->x();
  float x_pos = (float)x / (float)width() * mMaxValue;
  emit SgnPositionChange(x_pos);
}
