#ifndef AlivcLivePlayr_Player_Progress_h
#define AlivcLivePlayr_Player_Progress_h

#include <QFrame>

class AlivcPlayerProgress : public QFrame
{
  Q_OBJECT

public:
  AlivcPlayerProgress(QWidget *parent);
  ~AlivcPlayerProgress();
  void SetRange(float minValue, float maxValue);
  void SetPosition(float position);
  float GetPosition() { return mPosition; }
  void SetBufferPosition(float bufferPosition);
  float GetBufferPosition() { return mBufferPostion; }
  float GetMaxValue() { return mMaxValue; }
  float GetMinValue() { return mMinValue; }

signals:
  void SgnPositionChange(float pos);

protected:
  void paintEvent(QPaintEvent *);
  void mouseReleaseEvent(QMouseEvent *event);
  void mouseDoubleClickEvent(QMouseEvent *event);

private:
  float mMaxValue{ 100.f };
  float mMinValue{ 0.f };
  float mPosition{ 0.f };
  float mBufferPostion{ 0.f };
};

#endif // AlivcLivePlayr_Player_Progress_h