#pragma once
#include "windows.h"
#define SDL_MAIN_HANDLED
#include <SDL2/SDL.h>

class AlivcVideoRender {
public:
    AlivcVideoRender(HWND hwnd);
    ~AlivcVideoRender();
    void init(HWND hwnd);
    void uninit();
    void renderData(void **yuvData, int *lineSize, int width, int height);

private:
    void recreateTextureIfNeed(int videoWidth, int videoHeight);
    SDL_Rect getDestRet();
    bool mInited = false;
    SDL_Window *mVideoWindow = nullptr;
    SDL_Texture *mVideoTexture = nullptr;
    SDL_Renderer *mVideoRender = nullptr;
    int mVideoWidth = 0;
    int mVideoHeight = 0;
    int mWindowWidth = 720;
    int mWindowHeight = 360;
};
